diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/examples-to-run.py ns-3.41/examples/wireless/examples-to-run.py
--- ns-3.40/examples/wireless/examples-to-run.py	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/examples-to-run.py	2024-02-09 14:44:07.841789700 -0800
@@ -15,9 +15,9 @@
     ("wifi-multirate --totalTime=0.3s --rateManager=ns3::MinstrelWifiManager", "True", "False"),
     ("wifi-multirate --totalTime=0.3s --rateManager=ns3::OnoeWifiManager", "True", "False"),
     ("wifi-multirate --totalTime=0.3s --rateManager=ns3::RraaWifiManager", "True", "False"),
-    ("wifi-adhoc", "False", "True"), # Takes too long to run
-    ("wifi-ap --verbose=0", "True", "True"), # Don't let it spew to stdout
-    ("wifi-clear-channel-cmu", "False", "True"), # Requires specific hardware
+    ("wifi-adhoc", "False", "True"),  # Takes too long to run
+    ("wifi-ap --verbose=0", "True", "True"),  # Don't let it spew to stdout
+    ("wifi-clear-channel-cmu", "False", "True"),  # Requires specific hardware
     ("wifi-simple-adhoc", "True", "True"),
     ("wifi-simple-adhoc-grid", "True", "True"),
     ("wifi-simple-infra", "True", "True"),
@@ -26,12 +26,36 @@
     ("wifi-sleep", "True", "True"),
     ("wifi-blockack", "True", "True"),
     ("wifi-timing-attributes --simulationTime=1", "True", "True"),
-    ("wifi-power-adaptation-distance --manager=ns3::ParfWifiManager --outputFileName=parf --steps=5 --stepsSize=10", "True", "True"),
-    ("wifi-power-adaptation-distance --manager=ns3::AparfWifiManager --outputFileName=aparf --steps=5 --stepsSize=10", "True", "False"),
-    ("wifi-power-adaptation-distance --manager=ns3::RrpaaWifiManager --outputFileName=rrpaa --steps=5 --stepsSize=10", "True", "False"),
-    ("wifi-rate-adaptation-distance --standard=802.11a --staManager=ns3::MinstrelWifiManager --apManager=ns3::MinstrelWifiManager --outputFileName=minstrel --stepsSize=50 --stepsTime=0.1", "True", "False"),
-    ("wifi-rate-adaptation-distance --standard=802.11a --staManager=ns3::MinstrelWifiManager --apManager=ns3::MinstrelWifiManager --outputFileName=minstrel --stepsSize=50 --stepsTime=0.1 --STA1_x=-200", "True", "False"),
-    ("wifi-rate-adaptation-distance --staManager=ns3::MinstrelHtWifiManager --apManager=ns3::MinstrelHtWifiManager --outputFileName=minstrelHt --shortGuardInterval=true --channelWidth=40 --stepsSize=50 --stepsTime=0.1", "True", "False"),
+    (
+        "wifi-power-adaptation-distance --manager=ns3::ParfWifiManager --outputFileName=parf --steps=5 --stepsSize=10",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-power-adaptation-distance --manager=ns3::AparfWifiManager --outputFileName=aparf --steps=5 --stepsSize=10",
+        "True",
+        "False",
+    ),
+    (
+        "wifi-power-adaptation-distance --manager=ns3::RrpaaWifiManager --outputFileName=rrpaa --steps=5 --stepsSize=10",
+        "True",
+        "False",
+    ),
+    (
+        "wifi-rate-adaptation-distance --standard=802.11a --staManager=ns3::MinstrelWifiManager --apManager=ns3::MinstrelWifiManager --outputFileName=minstrel --stepsSize=50 --stepsTime=0.1",
+        "True",
+        "False",
+    ),
+    (
+        "wifi-rate-adaptation-distance --standard=802.11a --staManager=ns3::MinstrelWifiManager --apManager=ns3::MinstrelWifiManager --outputFileName=minstrel --stepsSize=50 --stepsTime=0.1 --STA1_x=-200",
+        "True",
+        "False",
+    ),
+    (
+        "wifi-rate-adaptation-distance --staManager=ns3::MinstrelHtWifiManager --apManager=ns3::MinstrelHtWifiManager --outputFileName=minstrelHt --shortGuardInterval=true --channelWidth=40 --stepsSize=50 --stepsTime=0.1",
+        "True",
+        "False",
+    ),
     ("wifi-power-adaptation-interference --simuTime=5", "True", "False"),
     ("wifi-dsss-validation", "True", "True"),
     ("wifi-ofdm-validation", "True", "True"),
@@ -40,37 +64,145 @@
     ("wifi-ofdm-he-validation", "True", "True"),
     ("wifi-error-models-comparison", "True", "True"),
     ("wifi-80211n-mimo --simulationTime=0.1 --step=10", "True", "True"),
-    ("wifi-ht-network --simulationTime=0.2 --frequency=5 --useRts=0 --minExpectedThroughput=5 --maxExpectedThroughput=135", "True", "True"),
-    ("wifi-ht-network --simulationTime=0.2 --frequency=5 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=132", "True", "True"),
-    ("wifi-ht-network --simulationTime=0.2 --frequency=2.4 --useRts=0 --minExpectedThroughput=5 --maxExpectedThroughput=132", "True", "True"),
-    ("wifi-ht-network --simulationTime=0.2 --frequency=2.4 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=129", "True", "True"),
-    ("wifi-vht-network --simulationTime=0.2 --useRts=0  --minExpectedThroughput=5 --maxExpectedThroughput=583", "True", "True"),
-    ("wifi-vht-network --simulationTime=0.2 --useRts=1  --minExpectedThroughput=5 --maxExpectedThroughput=557", "True", "True"),
-    ("wifi-he-network --simulationTime=0.25 --frequency=5 --useRts=0 --minExpectedThroughput=6 --maxExpectedThroughput=844", "True", "True"),
-    ("wifi-he-network --simulationTime=0.3 --frequency=5 --useRts=0 --useExtendedBlockAck=1 --minExpectedThroughput=6 --maxExpectedThroughput=1033", "True", "True"),
-    ("wifi-he-network --simulationTime=0.3 --frequency=5 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=745", "True", "True"),
-    ("wifi-he-network --simulationTime=0.25 --frequency=2.4 --useRts=0 --minExpectedThroughput=6 --maxExpectedThroughput=238", "True", "True"),
-    ("wifi-he-network --simulationTime=0.3 --frequency=2.4 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=223", "True", "True"),
-    ("wifi-he-network --simulationTime=0.3 --udp=0 --downlink=1 --useRts=0 --nStations=4 --dlAckType=ACK-SU-FORMAT --enableUlOfdma=1 --enableBsrp=0 --mcs=4 --minExpectedThroughput=20 --maxExpectedThroughput=212", "True", "True"),
-    ("wifi-he-network --simulationTime=0.3 --frequency=2.4 --udp=0 --downlink=1 --useRts=1 --nStations=5 --dlAckType=MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mcs=5 --minExpectedThroughput=27 --maxExpectedThroughput=50", "True", "True"),
-    ("wifi-he-network --simulationTime=0.3 --udp=0 --downlink=1 --useRts=0 --nStations=5 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=0 --mcs=6 --muSchedAccessReqInterval=50ms --minExpectedThroughput=31 --maxExpectedThroughput=290", "True", "True"),
-    ("wifi-he-network --simulationTime=0.3 --udp=1 --downlink=0 --useRts=1 --nStations=5 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mcs=5 --muSchedAccessReqInterval=50ms --minExpectedThroughput=46 --maxExpectedThroughput=327", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.1 --frequency=5 --useRts=0 --minExpectedThroughput=6 --maxExpectedThroughput=550", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.1 --frequency=5 --useRts=0 --useExtendedBlockAck=1 --frequency2=6 --minExpectedThroughput=12 --maxExpectedThroughput=550", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.1 --frequency=5 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=547", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.1 --frequency=2.4 --useRts=0 --useExtendedBlockAck=1 --frequency2=5 --minExpectedThroughput=12 --maxExpectedThroughput=500", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.1 --frequency=2.4 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=212", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.23 --udp=0 --downlink=1 --useRts=0 --nStations=4 --dlAckType=ACK-SU-FORMAT --enableUlOfdma=1 --enableBsrp=0 --mcs=4 --frequency2=6  --minExpectedThroughput=35 --maxExpectedThroughput=280", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.25 --frequency=2.4 --udp=0 --downlink=1 --useRts=0 --nStations=5 --dlAckType=MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mcs=5 --frequency2=5 --useExtendedBlockAck=1 --minExpectedThroughput=40 --maxExpectedThroughput=100", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.3 --udp=0 --downlink=1 --useRts=1 --nStations=5 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=0 --mcs=6 --muSchedAccessReqInterval=50ms --frequency2=2.4 --minExpectedThroughput=50 --maxExpectedThroughput=140", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.2 --udp=1 --downlink=0 --useRts=0 --nStations=5 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mcs=5 --muSchedAccessReqInterval=50ms --frequency2=6 --minExpectedThroughput=70 --maxExpectedThroughput=715", "True", "True"),
-    ("wifi-simple-ht-hidden-stations --simulationTime=1 --enableRts=0 --nMpdus=32 --minExpectedThroughput=59 --maxExpectedThroughput=60", "True", "True"),
-    ("wifi-simple-ht-hidden-stations --simulationTime=1 --enableRts=1 --nMpdus=32 --minExpectedThroughput=57 --maxExpectedThroughput=58", "True", "True"),
+    (
+        "wifi-ht-network --simulationTime=0.2 --frequency=5 --useRts=0 --minExpectedThroughput=5 --maxExpectedThroughput=135",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-ht-network --simulationTime=0.2 --frequency=5 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=132",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-ht-network --simulationTime=0.2 --frequency=2.4 --useRts=0 --minExpectedThroughput=5 --maxExpectedThroughput=132",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-ht-network --simulationTime=0.2 --frequency=2.4 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=129",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-vht-network --simulationTime=0.2 --useRts=0  --minExpectedThroughput=5 --maxExpectedThroughput=583",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-vht-network --simulationTime=0.2 --useRts=1  --minExpectedThroughput=5 --maxExpectedThroughput=557",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-he-network --simulationTime=0.25 --frequency=5 --useRts=0 --minExpectedThroughput=6 --maxExpectedThroughput=844",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-he-network --simulationTime=0.3 --frequency=5 --useRts=0 --useExtendedBlockAck=1 --minExpectedThroughput=6 --maxExpectedThroughput=1033",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-he-network --simulationTime=0.3 --frequency=5 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=745",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-he-network --simulationTime=0.25 --frequency=2.4 --useRts=0 --minExpectedThroughput=6 --maxExpectedThroughput=238",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-he-network --simulationTime=0.3 --frequency=2.4 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=223",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-he-network --simulationTime=0.3 --udp=0 --downlink=1 --useRts=0 --nStations=4 --dlAckType=ACK-SU-FORMAT --enableUlOfdma=1 --enableBsrp=0 --mcs=4 --minExpectedThroughput=20 --maxExpectedThroughput=212",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-he-network --simulationTime=0.3 --frequency=2.4 --udp=0 --downlink=1 --useRts=1 --nStations=5 --dlAckType=MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mcs=5 --minExpectedThroughput=27 --maxExpectedThroughput=50",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-he-network --simulationTime=0.3 --udp=0 --downlink=1 --useRts=0 --nStations=5 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=0 --mcs=6 --muSchedAccessReqInterval=50ms --minExpectedThroughput=31 --maxExpectedThroughput=290",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-he-network --simulationTime=0.3 --udp=1 --downlink=0 --useRts=1 --nStations=5 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mcs=5 --muSchedAccessReqInterval=50ms --minExpectedThroughput=46 --maxExpectedThroughput=327",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-eht-network --simulationTime=0.1 --frequency=5 --useRts=0 --minExpectedThroughput=6 --maxExpectedThroughput=550",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-eht-network --simulationTime=0.1 --frequency=5 --useRts=0 --mpduBufferSize=1024 --frequency2=6 --minExpectedThroughput=12 --maxExpectedThroughput=550",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-eht-network --simulationTime=0.1 --frequency=5 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=547",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-eht-network --simulationTime=0.1 --frequency=2.4 --useRts=0 --mpduBufferSize=512 --frequency2=5 --minExpectedThroughput=12 --maxExpectedThroughput=500",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-eht-network --simulationTime=0.1 --frequency=2.4 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=240",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-eht-network --simulationTime=0.23 --udp=0 --downlink=1 --useRts=0 --nStations=4 --dlAckType=ACK-SU-FORMAT --enableUlOfdma=1 --enableBsrp=0 --mcs=5 --frequency2=6  --minExpectedThroughput=35 --maxExpectedThroughput=280",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-eht-network --simulationTime=0.25 --frequency=2.4 --udp=0 --downlink=1 --useRts=0 --nStations=5 --dlAckType=MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mcs=5 --frequency2=5 --mpduBufferSize=1024 --minExpectedThroughput=50 --maxExpectedThroughput=120",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-eht-network --simulationTime=0.3 --udp=0 --downlink=1 --useRts=1 --nStations=5 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=0 --mcs=6 --muSchedAccessReqInterval=50ms --frequency2=2.4 --minExpectedThroughput=50 --maxExpectedThroughput=140",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-eht-network --simulationTime=0.2 --udp=0 --downlink=0 --useRts=0 --nStations=4 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mpduBufferSize=1024 --mcs=4 --muSchedAccessReqInterval=45ms --frequency2=6 --minExpectedThroughput=50 --maxExpectedThroughput=415",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-simple-ht-hidden-stations --simulationTime=1 --enableRts=0 --nMpdus=32 --minExpectedThroughput=59 --maxExpectedThroughput=60",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-simple-ht-hidden-stations --simulationTime=1 --enableRts=1 --nMpdus=32 --minExpectedThroughput=57 --maxExpectedThroughput=58",
+        "True",
+        "True",
+    ),
     ("wifi-mixed-network --simulationTime=1", "True", "True"),
     ("wifi-aggregation --simulationTime=1 --verifyResults=1", "True", "True"),
     ("wifi-txop-aggregation --simulationTime=1 --verifyResults=1", "True", "True"),
     ("wifi-80211e-txop --simulationTime=1 --verifyResults=1", "True", "True"),
-    ("wifi-multi-tos --simulationTime=1 --nWifi=16 --useRts=1 --useShortGuardInterval=1", "True", "True"),
+    (
+        "wifi-multi-tos --simulationTime=1 --nWifi=16 --useRts=1 --useShortGuardInterval=1",
+        "True",
+        "True",
+    ),
     ("wifi-tcp", "True", "True"),
     ("wifi-hidden-terminal --wifiManager=Arf", "True", "True"),
     ("wifi-hidden-terminal --wifiManager=Aarf", "True", "True"),
@@ -81,14 +213,42 @@
     ("wifi-hidden-terminal --wifiManager=Cara", "True", "True"),
     ("wifi-hidden-terminal --wifiManager=Rraa", "True", "True"),
     ("wifi-hidden-terminal --wifiManager=Rrpaa", "True", "True"),
-    ("wifi-spectrum-per-example --distance=52 --index=3 --wifiType=ns3::SpectrumWifiPhy --simulationTime=1", "True", "True"),
-    ("wifi-spectrum-per-example --distance=24 --index=31 --wifiType=ns3::YansWifiPhy --simulationTime=1", "True", "False"),
-    ("wifi-spectrum-per-interference --distance=24 --index=31 --simulationTime=1 --waveformPower=0.1", "True", "True"),
+    (
+        "wifi-spectrum-per-example --distance=52 --index=3 --wifiType=ns3::SpectrumWifiPhy --simulationTime=1",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-spectrum-per-example --distance=24 --index=31 --wifiType=ns3::YansWifiPhy --simulationTime=1",
+        "True",
+        "False",
+    ),
+    (
+        "wifi-spectrum-per-interference --distance=24 --index=31 --simulationTime=1 --waveformPower=0.1",
+        "True",
+        "True",
+    ),
     ("wifi-spectrum-saturation-example --simulationTime=1 --index=63", "True", "True"),
-    ("wifi-backward-compatibility --apVersion=80211a --staVersion=80211n_5GHZ --simulationTime=1", "True", "True"),
-    ("wifi-backward-compatibility --apVersion=80211a --staVersion=80211n_5GHZ --apRaa=Ideal --staRaa=Ideal --simulationTime=1", "True", "False"),
-    ("wifi-backward-compatibility --apVersion=80211a --staVersion=80211ac --simulationTime=1", "True", "False"),
-    ("wifi-backward-compatibility --apVersion=80211a --staVersion=80211ac --apRaa=Ideal --staRaa=Ideal --simulationTime=1", "True", "False"),
+    (
+        "wifi-backward-compatibility --apVersion=80211a --staVersion=80211n_5GHZ --simulationTime=1",
+        "True",
+        "True",
+    ),
+    (
+        "wifi-backward-compatibility --apVersion=80211a --staVersion=80211n_5GHZ --apRaa=Ideal --staRaa=Ideal --simulationTime=1",
+        "True",
+        "False",
+    ),
+    (
+        "wifi-backward-compatibility --apVersion=80211a --staVersion=80211ac --simulationTime=1",
+        "True",
+        "False",
+    ),
+    (
+        "wifi-backward-compatibility --apVersion=80211a --staVersion=80211ac --apRaa=Ideal --staRaa=Ideal --simulationTime=1",
+        "True",
+        "False",
+    ),
 ]
 
 # A list of Python examples to run in order to ensure that they remain
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/mixed-wired-wireless.py ns-3.41/examples/wireless/mixed-wired-wireless.py
--- ns-3.40/examples/wireless/mixed-wired-wireless.py	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/mixed-wired-wireless.py	2024-02-09 14:44:07.841789700 -0800
@@ -51,7 +51,14 @@
 #           +----------------+                       +----------------+
 #
 
-from ns import ns
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
 # #
 # #  This function will be used below as a trace sink
@@ -63,12 +70,14 @@
 #   std.cout << "CourseChange " << path << " x=" << position.x << ", y=" << position.y << ", z=" << position.z << std.endl;
 # }
 
+
 def main(argv):
     #
     #  First, we initialize a few local variables that control some
     #  simulation parameters.
     #
-    from ctypes import c_int, c_double
+    from ctypes import c_double, c_int
+
     backboneNodes = c_int(10)
     infraNodes = c_int(2)
     lanNodes = c_int(2)
@@ -99,8 +108,8 @@
     #
     cmd.Parse(argv)
 
-    if (stopTime.value < 10):
-        print ("Use a simulation stop time >= 10 seconds")
+    if stopTime.value < 10:
+        print("Use a simulation stop time >= 10 seconds")
         exit(1)
     # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # /
     #                                                                        #
@@ -121,8 +130,9 @@
     wifi = ns.wifi.WifiHelper()
     mac = ns.wifi.WifiMacHelper()
     mac.SetType("ns3::AdhocWifiMac")
-    wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
-                                  "DataMode", ns.core.StringValue("OfdmRate54Mbps"))
+    wifi.SetRemoteStationManager(
+        "ns3::ConstantRateWifiManager", "DataMode", ns.core.StringValue("OfdmRate54Mbps")
+    )
     wifiPhy = ns.wifi.YansWifiPhyHelper()
     wifiPhy.SetPcapDataLinkType(wifiPhy.DLT_IEEE802_11_RADIO)
     wifiChannel = ns.wifi.YansWifiChannelHelper.Default()
@@ -131,11 +141,12 @@
     #
     #  Add the IPv4 protocol stack to the nodes in our container
     #
-    print ("Enabling OLSR routing on all backbone nodes")
+    print("Enabling OLSR routing on all backbone nodes")
     internet = ns.internet.InternetStackHelper()
     olsr = ns.olsr.OlsrHelper()
-    internet.SetRoutingHelper(olsr); # has effect on the next Install ()
-    internet.Install(backbone);
+    internet.SetRoutingHelper(olsr)
+    # has effect on the next Install ()
+    internet.Install(backbone)
     # re-initialize for non-olsr routing.
     # internet.Reset()
     #
@@ -151,17 +162,30 @@
     #  each of the nodes we just finished building.
     #
     mobility = ns.mobility.MobilityHelper()
-    mobility.SetPositionAllocator("ns3::GridPositionAllocator",
-                                  "MinX", ns.core.DoubleValue(20.0),
-                                  "MinY", ns.core.DoubleValue(20.0),
-                                  "DeltaX", ns.core.DoubleValue(20.0),
-                                  "DeltaY", ns.core.DoubleValue(20.0),
-                                  "GridWidth", ns.core.UintegerValue(5),
-                                  "LayoutType", ns.core.StringValue("RowFirst"))
-    mobility.SetMobilityModel("ns3::RandomDirection2dMobilityModel",
-                               "Bounds", ns.mobility.RectangleValue(ns.mobility.Rectangle(-500, 500, -500, 500)),
-                               "Speed", ns.core.StringValue ("ns3::ConstantRandomVariable[Constant=2]"),
-                               "Pause", ns.core.StringValue ("ns3::ConstantRandomVariable[Constant=0.2]"))
+    mobility.SetPositionAllocator(
+        "ns3::GridPositionAllocator",
+        "MinX",
+        ns.core.DoubleValue(20.0),
+        "MinY",
+        ns.core.DoubleValue(20.0),
+        "DeltaX",
+        ns.core.DoubleValue(20.0),
+        "DeltaY",
+        ns.core.DoubleValue(20.0),
+        "GridWidth",
+        ns.core.UintegerValue(5),
+        "LayoutType",
+        ns.core.StringValue("RowFirst"),
+    )
+    mobility.SetMobilityModel(
+        "ns3::RandomDirection2dMobilityModel",
+        "Bounds",
+        ns.mobility.RectangleValue(ns.mobility.Rectangle(-500, 500, -500, 500)),
+        "Speed",
+        ns.core.StringValue("ns3::ConstantRandomVariable[Constant=2]"),
+        "Pause",
+        ns.core.StringValue("ns3::ConstantRandomVariable[Constant=0.2]"),
+    )
     mobility.Install(backbone)
 
     # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # /
@@ -175,7 +199,7 @@
     ipAddrs.SetBase(ns.network.Ipv4Address("172.16.0.0"), ns.network.Ipv4Mask("255.255.255.0"))
 
     for i in range(backboneNodes.value):
-        print ("Configuring local area network for backbone node ", i)
+        print("Configuring local area network for backbone node ", i)
         #
         #  Create a container to manage the nodes of the LAN.  We need
         #  two containers here; one with all of the new nodes, and one
@@ -214,12 +238,12 @@
         mobilityLan = ns.mobility.MobilityHelper()
         positionAlloc = ns.mobility.ListPositionAllocator()
         for j in range(newLanNodes.GetN()):
-            positionAlloc.Add(ns.core.Vector(0.0, (j*10 + 10), 0.0))
+            positionAlloc.Add(ns.core.Vector(0.0, (j * 10 + 10), 0.0))
 
         mobilityLan.SetPositionAllocator(positionAlloc)
         mobilityLan.PushReferenceMobilityModel(backbone.Get(i))
         mobilityLan.SetMobilityModel("ns3::ConstantPositionMobilityModel")
-        mobilityLan.Install(newLanNodes);
+        mobilityLan.Install(newLanNodes)
 
     # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # /
     #                                                                        #
@@ -232,7 +256,7 @@
     ipAddrs.SetBase(ns.network.Ipv4Address("10.0.0.0"), ns.network.Ipv4Mask("255.255.255.0"))
     tempRef = []  # list of references to be held to prevent garbage collection
     for i in range(backboneNodes.value):
-        print ("Configuring wireless network for backbone node ", i)
+        print("Configuring wireless network for backbone node ", i)
         #
         #  Create a container to manage the nodes of the LAN.  We need
         #  two containers here; one with all of the new nodes, and one
@@ -245,18 +269,16 @@
         #
         #  Create another ad hoc network and devices
         #
-        ssid = ns.wifi.Ssid('wifi-infra' + str(i))
+        ssid = ns.wifi.Ssid("wifi-infra" + str(i))
         wifiInfra = ns.wifi.WifiHelper()
         wifiPhy.SetChannel(wifiChannel.Create())
-        macInfra = ns.wifi.WifiMacHelper();
-        macInfra.SetType("ns3::StaWifiMac",
-                         "Ssid", ns.wifi.SsidValue(ssid))
+        macInfra = ns.wifi.WifiMacHelper()
+        macInfra.SetType("ns3::StaWifiMac", "Ssid", ns.wifi.SsidValue(ssid))
 
         # setup stas
         staDevices = wifiInfra.Install(wifiPhy, macInfra, stas)
         # setup ap.
-        macInfra.SetType("ns3::ApWifiMac",
-                         "Ssid", ns.wifi.SsidValue(ssid))
+        macInfra.SetType("ns3::ApWifiMac", "Ssid", ns.wifi.SsidValue(ssid))
         apDevices = wifiInfra.Install(wifiPhy, macInfra, backbone.Get(i))
         # Collect all of these new devices
         infraDevices = ns.network.NetDeviceContainer(apDevices, staDevices)
@@ -291,10 +313,15 @@
 
         mobility.PushReferenceMobilityModel(backbone.Get(i))
         mobility.SetPositionAllocator(subnetAlloc)
-        mobility.SetMobilityModel("ns3::RandomDirection2dMobilityModel",
-                                  "Bounds", ns.mobility.RectangleValue(ns.mobility.Rectangle(-10, 10, -10, 10)),
-                                  "Speed", ns.core.StringValue ("ns3::ConstantRandomVariable[Constant=3]"),
-                                  "Pause", ns.core.StringValue ("ns3::ConstantRandomVariable[Constant=0.4]"))
+        mobility.SetMobilityModel(
+            "ns3::RandomDirection2dMobilityModel",
+            "Bounds",
+            ns.mobility.RectangleValue(ns.mobility.Rectangle(-10, 10, -10, 10)),
+            "Speed",
+            ns.core.StringValue("ns3::ConstantRandomVariable[Constant=3]"),
+            "Pause",
+            ns.core.StringValue("ns3::ConstantRandomVariable[Constant=0.4]"),
+        )
         mobility.Install(stas)
 
     # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # /
@@ -305,18 +332,25 @@
 
     #  Create the OnOff application to send UDP datagrams of size
     #  210 bytes at a rate of 448 Kb/s, between two nodes
-    print ("Create Applications.")
-    port = 9   #  Discard port(RFC 863)
+    print("Create Applications.")
+    port = 9  #  Discard port(RFC 863)
 
     appSource = ns.network.NodeList.GetNode(backboneNodes.value)
-    lastNodeIndex = backboneNodes.value + backboneNodes.value*(lanNodes.value - 1) + backboneNodes.value*(infraNodes.value - 1) - 1
+    lastNodeIndex = (
+        backboneNodes.value
+        + backboneNodes.value * (lanNodes.value - 1)
+        + backboneNodes.value * (infraNodes.value - 1)
+        - 1
+    )
     appSink = ns.network.NodeList.GetNode(lastNodeIndex)
 
-    ns.cppyy.cppdef("""
+    ns.cppyy.cppdef(
+        """
         Ipv4Address getIpv4AddressFromNode(Ptr<Node> node){
         return node->GetObject<Ipv4>()->GetAddress(1,0).GetLocal();
         }
-    """)
+    """
+    )
     # Let's fetch the IP address of the last node, which is on Ipv4Interface 1
     remoteAddr = ns.cppyy.gbl.getIpv4AddressFromNode(appSink)
     socketAddr = ns.network.InetSocketAddress(remoteAddr, port)
@@ -326,8 +360,12 @@
     apps.Stop(ns.core.Seconds(stopTime.value - 1))
 
     #  Create a packet sink to receive these packets
-    sink = ns.applications.PacketSinkHelper("ns3::UdpSocketFactory",
-                                ns.network.InetSocketAddress(ns.network.InetSocketAddress(ns.network.Ipv4Address.GetAny(), port)).ConvertTo())
+    sink = ns.applications.PacketSinkHelper(
+        "ns3::UdpSocketFactory",
+        ns.network.InetSocketAddress(
+            ns.network.InetSocketAddress(ns.network.Ipv4Address.GetAny(), port)
+        ).ConvertTo(),
+    )
     sinkContainer = ns.network.NodeContainer(appSink)
     apps = sink.Install(sinkContainer)
     apps.Start(ns.core.Seconds(3))
@@ -338,16 +376,16 @@
     #                                                                        #
     # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # /
 
-    print ("Configure Tracing.")
+    print("Configure Tracing.")
     csma = ns.csma.CsmaHelper()
     #
     #  Let's set up some ns-2-like ascii traces, using another helper class
     #
-    ascii = ns.network.AsciiTraceHelper();
-    stream = ascii.CreateFileStream("mixed-wireless.tr");
-    wifiPhy.EnableAsciiAll(stream);
-    csma.EnableAsciiAll(stream);
-    internet.EnableAsciiIpv4All(stream);
+    ascii = ns.network.AsciiTraceHelper()
+    stream = ascii.CreateFileStream("mixed-wireless.tr")
+    wifiPhy.EnableAsciiAll(stream)
+    csma.EnableAsciiAll(stream)
+    internet.EnableAsciiIpv4All(stream)
 
     #  Csma captures in non-promiscuous mode
     csma.EnablePcapAll("mixed-wireless", False)
@@ -355,11 +393,10 @@
     wifiPhy.EnablePcap("mixed-wireless", backboneDevices)
     wifiPhy.EnablePcap("mixed-wireless", appSink.GetId(), 0)
 
-#   #ifdef ENABLE_FOR_TRACING_EXAMPLE
-#     Config.Connect("/NodeList/*/$MobilityModel/CourseChange",
-#       MakeCallback(&CourseChangeCallback))
-#   #endif
-
+    #   #ifdef ENABLE_FOR_TRACING_EXAMPLE
+    #     Config.Connect("/NodeList/*/$MobilityModel/CourseChange",
+    #       MakeCallback(&CourseChangeCallback))
+    #   #endif
 
     # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
     #                                                                        #
@@ -367,13 +404,13 @@
     #                                                                        #
     # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
 
-    print ("Run Simulation.")
+    print("Run Simulation.")
     ns.core.Simulator.Stop(ns.core.Seconds(stopTime.value))
     ns.core.Simulator.Run()
     ns.core.Simulator.Destroy()
 
-if __name__ == '__main__':
-    import sys
-    main(sys.argv)
 
+if __name__ == "__main__":
+    import sys
 
+    main(sys.argv)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-80211e-txop.cc ns-3.41/examples/wireless/wifi-80211e-txop.cc
--- ns-3.40/examples/wireless/wifi-80211e-txop.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/wifi-80211e-txop.cc	2024-02-09 14:44:07.841789700 -0800
@@ -28,6 +28,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/wifi-mac.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/yans-wifi-channel.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-80211n-mimo.cc ns-3.41/examples/wireless/wifi-80211n-mimo.cc
--- ns-3.40/examples/wireless/wifi-80211n-mimo.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/wifi-80211n-mimo.cc	2024-02-09 14:44:07.841789700 -0800
@@ -51,6 +51,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-aggregation.cc ns-3.41/examples/wireless/wifi-aggregation.cc
--- ns-3.40/examples/wireless/wifi-aggregation.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/wifi-aggregation.cc	2024-02-09 14:44:07.841789700 -0800
@@ -28,6 +28,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/wifi-mac.h"
 #include "ns3/wifi-net-device.h"
